package model;

import java.util.ArrayList;

public class Kamikaze extends Pawn { // aka Trojan knight :P
    public Kamikaze(Position p, int color) {
        super(p, color);
    }

    @Override
    public ArrayList<Position> getAvailableMoves(Board b) {

        ArrayList<Position> moves = new ArrayList<>();
        Position arrival;

        // list of the 8 kamikaze-knight specific movements
        int[] all_x = {1, 2, 2, 1, -1, -2, -2, -1};
        int[] all_y = {2, 1, -1, -2, -2, -1, 1, 2};

        for(int n = 0 ; n < all_x.length ; n++) { // for each direction
            int x = all_x[n];
            int y = all_y[n];
            arrival = new Position(p.getX() + x, p.getY() + y);
            if (b.isEnemy(arrival, p) || b.isFree(arrival)) {
                moves.add(arrival);
            }
        }
        return moves;
    }

    public ArrayList<Position> getExplosion() {

        ArrayList<Position> moves = new ArrayList<>();
        Position target;

        for(int x = -1 ; x <= 1 ; x++) {
            for(int y = -1 ; y <= 1 ; y++) {
                target = new Position(p.getX() + x, p.getY() + y);
                if (target.isCorrect()) {
                    moves.add(target);
                }
            }
        }
        return moves;
    }

    public Piece newInstanceCopy() {
        return new Kamikaze(p, color);
    }
}
